.\"	$NetBSD: getdomainname.3,v 1.14 2003/04/16 13:34:36 wiz Exp $
.\"
.\" Copyright (c) 1983, 1991, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     @(#)gethostname.3	8.1 (Berkeley) 6/4/93
.\"
.Dd May 6, 1994
.Dt GETDOMAINNAME 3
.Os
.Sh NAME
.Nm getdomainname ,
.Nm setdomainname
.Nd get/set domain name of current host
.Sh LIBRARY
.Lb libc
.Sh SYNOPSIS
.In unistd.h
.Ft int
.Fn getdomainname "char *name" "size_t namelen"
.Ft int
.Fn setdomainname "const char *name" "size_t namelen"
.Sh DESCRIPTION
.Fn getdomainname
returns the standard domain name for the current processor, as
previously set by
.Fn setdomainname .
The parameter
.Fa namelen
specifies the size of the
.Fa name
array.
The returned name is null-terminated unless insufficient
space is provided.
.Pp
.Fn setdomainname
sets the domain name of the host machine to be
.Fa name ,
which has length
.Fa namelen .
This call is restricted to the super-user and
is normally used only when the system is bootstrapped.
.Sh RETURN VALUES
If the call succeeds a value of 0 is returned.
If the call fails, a value of \-1 is returned and an error code is
placed in the global location
.Va errno .
.Sh ERRORS
The following errors may be returned by these calls:
.Bl -tag -width Er
.It Bq Er EFAULT
The
.Fa name
or
.Fa namelen
parameter gave an
invalid address.
.It Bq Er EPERM
The caller tried to set the domain name and was not the super-user.
.El
.Sh SEE ALSO
.Xr gethostid 3 ,
.Xr gethostname 3 ,
.Xr sysctl 3
.Sh HISTORY
The
.Nm
function call appeared in
.Bx 4.2 .
.Sh BUGS
Domain names are limited to
.Dv MAXHOSTNAMELEN
(from
.Ao Pa sys/param.h Ac )
characters including null-termination, currently 256.
